require 'minitest/autorun'
require 'github-pr/cli'
module GitHubPr
	describe CLI do
		
		describe "when passed only assigner" do
			it "must contain assign field" do
				CLI.parse(['-a', 'hovox'])[:assign].must_equal 'hovox'
			end
		end

		describe "when does not passed assigner argument" do
			it "must raise an runtime error" do
				-> { CLI.parse(['-b', 'master', '-f', 'shop']) }.must_raise RuntimeError
			end
		end

		describe "when does not passed base branch" do
			it "must take master as base branch" do
				CLI.parse(['-a', 'hovox'])[:base].must_equal 'master'
			end
		end


		describe "when does not passed base branch" do
			it "must take master as base branch" do
				CLI.parse(['-a', 'hovox'])[:base].must_equal 'master'
			end
		end

		describe "when passed token and assagnee" do
			it "must contain assign field" do
				options = CLI.parse(['-a', 'hovox', '-g', 'sometoken'])
				options[:token].must_equal 'sometoken'
				options[:base].must_equal 'master'

			end
		end

		describe "when passed token, assagnee and repo url" do
			it "must contain assign field" do
				options = CLI.parse(['-a', 'hovox', '-g', 'sometoken', '-u', 'https://somegithuburl.com'])
				options[:token].must_equal 'sometoken'
				options[:base].must_equal 'master'
				options[:assign].must_equal 'hovox'
				options[:url].must_equal 'https://somegithuburl.com'
			end
		end

	end

end