require 'minitest/autorun'
require 'github-pr/token'

module GitHubPr

  describe Token do

    describe "Token object creation" do
      it "must return FixedToken object" do
        token = Token.create(token_file_path:"some_path", direct_token:"direct_token")
        token.class.name.must_equal "GitHubPr::FixedToken"
      end

      it "must return FileToken object" do
        token = Token.create(token_file_path:"some_path", direct_token:nil)
        token.class.name.must_equal "GitHubPr::FileToken"
      end
    end 

    describe "File cache" do
      it "must present after creation" do
        path = File.expand_path '~/.config/gh-pr-token'
        token = Token.create(token_file_path:path)
        token.create_dir_if_needed()
        token_dir = File.dirname(path)
			  isDirExist = File.directory?(token_dir)
        isDirExist.must_equal true
      end

      it "must return token from file if exists" do
        some_token = '14bebe34582d1dc606d72f36df0886d699ff04e5'
        path = File.expand_path '~/.config/gh-pr-token'
        # puts 'cache path is:' + path

        token = Token.create(token_file_path:path, direct_token:nil)
        token.create_dir_if_needed()
        token.token_from_file().must_equal some_token

      end
    end

    # describe "Token object creation" do
      
    # end
    

  end

end